diff --git a/src/common/address.c b/src/common/address.c
index d0c2d5e..2803540 100644
--- a/src/common/address.c
+++ b/src/common/address.c
@@ -53,9 +53,9 @@
 #include <assert.h>
 
 /** Convert the tor_addr_t in <b>a</b>, with port in <b>port</b>, into a
- * sockaddr object in *<b>sa_out</b> of object size <b>len</b>.  If not enough
- * room is available in sa_out, or on error, return 0.  On success, return
- * the length of the sockaddr.
+ * sockaddr_storage object in *<b>sa_out</b> of object size <b>len</b>.
+ * If not enough room is available in sa_out, or on error, return 0.
+ * On success, return the length of the sockaddr.
  *
  * Interface note: ordinarily, we return -1 for error.  We can't do that here,
  * since socklen_t is unsigned on some platforms.
@@ -63,18 +63,24 @@
 socklen_t
 tor_addr_to_sockaddr(const tor_addr_t *a,
                      uint16_t port,
-                     struct sockaddr *sa_out,
+                     struct sockaddr_storage *sa_out,
                      socklen_t len)
 {
+  /*
+   * Require sockaddr_storage to be used throughout the code
+   * as that is the only way to be future proof
+   * We could swap tor_addr_t with sockaddr_storage completely actually
+   */
   sa_family_t family = tor_addr_family(a);
+  tor_assert(len == sizeof(*sa_out));
+  memset(sa_out, 0, len);
   if (family == AF_INET) {
     struct sockaddr_in *sin;
-    if (len < (int)sizeof(struct sockaddr_in))
+    if (len < (int)sizeof(*sin))
       return 0;
     sin = (struct sockaddr_in *)sa_out;
-    memset(sin, 0, sizeof(struct sockaddr_in));
 #ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
-    sin->sin_len = sizeof(struct sockaddr_in);
+    sin->sin_len = sizeof(*sin);
 #endif
     sin->sin_family = AF_INET;
     sin->sin_port = htons(port);
@@ -82,17 +88,16 @@ tor_addr_to_sockaddr(const tor_addr_t *a,
     return sizeof(struct sockaddr_in);
   } else if (family == AF_INET6) {
     struct sockaddr_in6 *sin6;
-    if (len < (int)sizeof(struct sockaddr_in6))
+    if (len < (int)sizeof(*sin6))
       return 0;
     sin6 = (struct sockaddr_in6 *)sa_out;
-    memset(sin6, 0, sizeof(struct sockaddr_in6));
 #ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
-    sin6->sin6_len = sizeof(struct sockaddr_in6);
+    sin6->sin6_len = sizeof(*sin6);
 #endif
     sin6->sin6_family = AF_INET6;
     sin6->sin6_port = htons(port);
     memcpy(&sin6->sin6_addr, tor_addr_to_in6(a), sizeof(struct in6_addr));
-    return sizeof(struct sockaddr_in6);
+    return sizeof(*sin6);
   } else {
     return 0;
   }
@@ -123,33 +128,6 @@ tor_addr_from_sockaddr(tor_addr_t *a, const struct sockaddr *sa,
   return 0;
 }
 
-/** Return a newly allocated string holding the address described in
- * <b>sa</b>.  AF_UNIX, AF_UNSPEC, AF_INET, and AF_INET6 are supported. */
-char *
-tor_sockaddr_to_str(const struct sockaddr *sa)
-{
-  char address[TOR_ADDR_BUF_LEN];
-  char *result;
-  tor_addr_t addr;
-  uint16_t port;
-#ifdef HAVE_SYS_UN_H
-  if (sa->sa_family == AF_UNIX) {
-    struct sockaddr_un *s_un = (struct sockaddr_un *)sa;
-    tor_asprintf(&result, "unix:%s", s_un->sun_path);
-    return result;
-  }
-#endif
-  if (sa->sa_family == AF_UNSPEC)
-    return tor_strdup("unspec");
-
-  if (tor_addr_from_sockaddr(&addr, sa, &port) < 0)
-    return NULL;
-  if (! tor_addr_to_str(address, &addr, sizeof(address), 1))
-    return NULL;
-  tor_asprintf(&result, "%s:%d", address, (int)port);
-  return result;
-}
-
 /** Set address <b>a</b> to the unspecified address.  This address belongs to
  * no family. */
 void
@@ -173,24 +151,20 @@ tor_addr_lookup(const char *name, uint16_t family, tor_addr_t *addr)
   /* Perhaps eventually this should be replaced by a tor_getaddrinfo or
    * something.
    */
-  struct in_addr iaddr;
-  struct in6_addr iaddr6;
   tor_assert(name);
   tor_assert(addr);
   tor_assert(family == AF_INET || family == AF_INET6 || family == AF_UNSPEC);
   if (!*name) {
     /* Empty address is an error. */
     return -1;
-  } else if (tor_inet_pton(AF_INET, name, &iaddr)) {
+  } else if (tor_inet_pton(AF_INET, name, addr)) {
     /* It's an IPv4 IP. */
     if (family == AF_INET6)
       return -1;
-    tor_addr_from_in(addr, &iaddr);
     return 0;
-  } else if (tor_inet_pton(AF_INET6, name, &iaddr6)) {
+  } else if (tor_inet_pton(AF_INET6, name, addr)) {
     if (family == AF_INET)
       return -1;
-    tor_addr_from_in6(addr, &iaddr6);
     return 0;
   } else {
 #ifdef HAVE_GETADDRINFO
@@ -287,8 +261,7 @@ tor_addr_is_internal(const tor_addr_t *addr, int for_listening)
 {
   uint32_t iph4 = 0;
   uint32_t iph6[4];
-  sa_family_t v_family;
-  v_family = tor_addr_family(addr);
+  sa_family_t v_family = tor_addr_family(addr);
 
   if (v_family == AF_INET) {
     iph4 = tor_addr_to_ipv4h(addr);
@@ -333,7 +306,7 @@ tor_addr_is_internal(const tor_addr_t *addr, int for_listening)
 
   /* unknown address family... assume it's not safe for external use */
   /* rather than tor_assert(0) */
-  log_warn(LD_BUG, "tor_addr_is_internal() called with a non-IP address.");
+  log_warn(LD_BUG, "tor_addr_is_internal() called with a non-IPv%u (AF%u) address.", v_family == AF_INET6 ? 6 : 4, v_family);
   return 1;
 }
 
@@ -343,8 +316,11 @@ tor_addr_is_internal(const tor_addr_t *addr, int for_listening)
  *  brackets.
  */
 const char *
-tor_addr_to_str(char *dest, const tor_addr_t *addr, size_t len, int decorate)
+tor_addr_to_str(const tor_addr_t *addr, char *dest, size_t len, int decorate)
 {
+#ifdef HAVE_SYS_UN_H
+  struct sockaddr_un *s_un;
+#endif
   const char *ptr;
   tor_assert(addr && dest);
 
@@ -366,6 +342,17 @@ tor_addr_to_str(char *dest, const tor_addr_t *addr, size_t len, int decorate)
         ptr = dest;
       }
       break;
+#ifdef HAVE_SYS_UN_H
+    case AF_UNIX:
+      s_un = (struct sockaddr_un *)addr; /* XXX-IPv6: broken */
+      tor_snprintf(dest, len, "unix:%s", s_un->sun_path);
+      ptr = dest;
+      break;
+#endif
+    case AF_UNSPEC:
+      tor_snprintf(dest, len, "unspec");
+      ptr = dest;
+      break;
     default:
       return NULL;
   }
@@ -391,7 +378,8 @@ tor_addr_parse_reverse_lookup_name(tor_addr_t *result, const char *address,
     /* We have an in-addr.arpa address. */
     char buf[INET_NTOA_BUF_LEN];
     size_t len;
-    struct in_addr inaddr;
+    unsigned a,b,c,d;
+    char more;
     if (family == AF_INET6)
       return -1;
 
@@ -401,18 +389,15 @@ tor_addr_parse_reverse_lookup_name(tor_addr_t *result, const char *address,
 
     memcpy(buf, address, len);
     buf[len] = '\0';
-    if (tor_inet_aton(buf, &inaddr) == 0)
-      return -1; /* malformed. */
 
-    /* reverse the bytes */
-    inaddr.s_addr = (uint32_t)
-      (((inaddr.s_addr & 0x000000ff) << 24)
-       |((inaddr.s_addr & 0x0000ff00) << 8)
-       |((inaddr.s_addr & 0x00ff0000) >> 8)
-       |((inaddr.s_addr & 0xff000000) >> 24));
-
-    if (result) {
-      tor_addr_from_in(result, &inaddr);
+    /* The %c is there to make sure that the full string is taken as input */
+    if (tor_sscanf(buf, "%3u.%3u.%3u.%3u%c", &d,&c,&b,&a,&more) == 4) {
+      if (a > 255) return 0;
+      if (b > 255) return 0;
+      if (c > 255) return 0;
+      if (d > 255) return 0;
+      if (result) tor_addr_from_ipv4n(result, htonl((a<<24) | (b<<16) | (c<<8) | d));
+      return 1;
     }
     return 1;
   }
@@ -534,8 +519,6 @@ tor_addr_parse_mask_ports(const char *s, tor_addr_t *addr_out,
   char *endptr;
   int any_flag=0, v4map=0;
   sa_family_t family;
-  struct in6_addr in6_tmp;
-  struct in_addr in_tmp;
 
   tor_assert(s);
   tor_assert(addr_out);
@@ -586,12 +569,10 @@ tor_addr_parse_mask_ports(const char *s, tor_addr_t *addr_out,
     family = AF_INET; /* AF_UNSPEC ???? XXXX_IP6 */
     tor_addr_from_ipv4h(addr_out, 0);
     any_flag = 1;
-  } else if (tor_inet_pton(AF_INET6, address, &in6_tmp) > 0) {
+  } else if (tor_inet_pton(AF_INET6, address, addr_out) > 0) {
     family = AF_INET6;
-    tor_addr_from_in6(addr_out, &in6_tmp);
-  } else if (tor_inet_pton(AF_INET, address, &in_tmp) > 0) {
+  } else if (tor_inet_pton(AF_INET, address, addr_out) > 0) {
     family = AF_INET;
-    tor_addr_from_in(addr_out, &in_tmp);
   } else {
     log_warn(LD_GENERAL, "Malformed IP %s in address pattern; rejecting.",
              escaped(address));
@@ -603,7 +584,7 @@ tor_addr_parse_mask_ports(const char *s, tor_addr_t *addr_out,
   /* Parse mask */
   if (maskbits_out) {
     int bits = 0;
-    struct in_addr v4mask;
+    tor_addr_t v4mask;
 
     if (mask) {  /* the caller (tried to) specify a mask */
       bits = (int) strtol(mask, &endptr, 10);
@@ -617,7 +598,7 @@ tor_addr_parse_mask_ports(const char *s, tor_addr_t *addr_out,
         }
       } else {  /* mask might still be an address-style mask */
         if (tor_inet_pton(AF_INET, mask, &v4mask) > 0) {
-          bits = addr_mask_get_bits(ntohl(v4mask.s_addr));
+          bits = tor_addr_mask_get_bits(&v4mask);
           if (bits < 0) {
             log_warn(LD_GENERAL,
                      "IPv4-style mask %s is not a prefix address; rejecting.",
@@ -743,12 +724,12 @@ tor_addr_is_loopback(const tor_addr_t *addr)
   tor_assert(addr);
   switch (tor_addr_family(addr)) {
     case AF_INET6: {
-      /* ::1 */
+      /* ::1  - we compare the last 32bits by first converting to the correct local endian */
       uint32_t *a32 = tor_addr_to_in6_addr32(addr);
-      return (a32[0] == 0) && (a32[1] == 0) && (a32[2] == 0) && (a32[3] == 1);
+      return (a32[0] == 0) && (a32[1] == 0) && (a32[2] == 0) && (ntohl(a32[3]) == 1);
     }
     case AF_INET:
-      /* 127.0.0.1 */
+      /* 127.0.0.1 - tor_addr_to_ipv4h handles endianess */
       return (tor_addr_to_ipv4h(addr) & 0xff000000) == 0x7f000000;
     case AF_UNSPEC:
       return 0;
@@ -758,6 +739,25 @@ tor_addr_is_loopback(const tor_addr_t *addr)
   }
 }
 
+/* XXX: Get rid of the difference with tor_addr_make_null() */
+void
+tor_addr_from_null(tor_addr_t *dest)
+{
+  memset(dest, 0, sizeof(*dest));
+  dest->family = AF_INET;
+}
+
+void
+tor_addr_from_loopback(tor_addr_t *dest, sa_family_t family)
+{
+  if (family == AF_INET) tor_addr_from_ipv4n(dest, htonl(0x7f000001u));
+  else
+  {
+    uint32_t bits[4] = {0,0,0,htonl(1)};
+    tor_addr_from_ipv6_bytes(dest, (const char *)bits);
+  }
+}
+
 /** Set <b>dest</b> to equal the IPv4 address in <b>v4addr</b> (given in
  * network order). */
 void
@@ -838,6 +838,12 @@ tor_addr_compare_masked(const tor_addr_t *addr1, const tor_addr_t *addr2,
 #define TRISTATE(a,b) (((a)<(b))?-1: (((a)==(b))?0:1))
   sa_family_t family1, family2, v_family1, v_family2;
 
+  /* When one of the two addresses is not there... */
+  /* (Might happen because of node address compares, should fix there maybe) */
+  if (!addr1 && addr2) return -1;
+  if (addr1 && !addr2) return 1;
+  if (!addr1 && !addr2) return 0;
+
   tor_assert(addr1 && addr2);
 
   v_family1 = family1 = tor_addr_family(addr1);
@@ -945,7 +951,7 @@ char *
 tor_dup_addr(const tor_addr_t *addr)
 {
   char buf[TOR_ADDR_BUF_LEN];
-  tor_addr_to_str(buf, addr, sizeof(buf), 0);
+  tor_addr_to_str(addr, buf, sizeof(buf), 0);
   return tor_strdup(buf);
 }
 
@@ -958,20 +964,7 @@ fmt_addr(const tor_addr_t *addr)
 {
   static char buf[TOR_ADDR_BUF_LEN];
   if (!addr) return "<null>";
-  tor_addr_to_str(buf, addr, sizeof(buf), 0);
-  return buf;
-}
-
-/** Like fmt_addr(), but takes <b>addr</b> as a host-order IPv4
- * addresses. Also not thread-safe, also clobbers its return buffer on
- * repeated calls. */
-const char *
-fmt_addr32(uint32_t addr)
-{
-  static char buf[INET_NTOA_BUF_LEN];
-  struct in_addr in;
-  in.s_addr = htonl(addr);
-  tor_inet_ntoa(&in, buf, sizeof(buf));
+  tor_addr_to_str(addr, buf, sizeof(buf), 0);
   return buf;
 }
 
@@ -986,18 +979,14 @@ tor_addr_from_str(tor_addr_t *addr, const char *src)
 {
   char *tmp = NULL; /* Holds substring if we got a dotted quad. */
   int result;
-  struct in_addr in_tmp;
-  struct in6_addr in6_tmp;
   tor_assert(addr && src);
   if (src[0] == '[' && src[1])
     src = tmp = tor_strndup(src+1, strlen(src)-2);
 
-  if (tor_inet_pton(AF_INET6, src, &in6_tmp) > 0) {
+  if (tor_inet_pton(AF_INET6, src, addr) > 0) {
     result = AF_INET6;
-    tor_addr_from_in6(addr, &in6_tmp);
-  } else if (tor_inet_pton(AF_INET, src, &in_tmp) > 0) {
+  } else if (tor_inet_pton(AF_INET, src, addr) > 0) {
     result = AF_INET;
-    tor_addr_from_in(addr, &in_tmp);
   } else {
     result = -1;
   }
@@ -1128,24 +1117,6 @@ get_interface_address6(int severity, sa_family_t family, tor_addr_t *addr)
   return r;
 }
 
-/* ======
- * IPv4 helpers
- * XXXX023 IPv6 deprecate some of these.
- */
-
-/** Return true iff <b>ip</b> (in host order) is an IP reserved to localhost,
- * or reserved for local networks by RFC 1918.
- */
-int
-is_internal_IP(uint32_t ip, int for_listening)
-{
-  tor_addr_t myaddr;
-  myaddr.family = AF_INET;
-  myaddr.addr.in_addr.s_addr = htonl(ip);
-
-  return tor_addr_is_internal(&myaddr, for_listening);
-}
-
 /** Parse a string of the form "host[:port]" from <b>addrport</b>.  If
  * <b>address</b> is provided, set *<b>address</b> to a copy of the
  * host portion of the string.  If <b>addr</b> is provided, try to
@@ -1158,7 +1129,7 @@ is_internal_IP(uint32_t ip, int for_listening)
  */
 int
 parse_addr_port(int severity, const char *addrport, char **address,
-                uint32_t *addr, uint16_t *port_out)
+                tor_addr_t *addr, uint16_t *port_out)
 {
   const char *colon;
   char *_address = NULL;
@@ -1190,10 +1161,10 @@ parse_addr_port(int severity, const char *addrport, char **address,
 
   if (addr) {
     /* There's an addr pointer, so we need to resolve the hostname. */
-    if (tor_lookup_hostname(_address,addr)) {
+    if (tor_addr_lookup(_address, AF_UNSPEC, addr)) {
       log_fn(severity, LD_NET, "Couldn't look up %s", escaped(_address));
       ok = 0;
-      *addr = 0;
+      tor_addr_from_null(addr);
     }
   }
 
@@ -1213,9 +1184,10 @@ parse_addr_port(int severity, const char *addrport, char **address,
 /** If <b>mask</b> is an address mask for a bit-prefix, return the number of
  * bits.  Otherwise, return -1. */
 int
-addr_mask_get_bits(uint32_t mask)
+tor_addr_mask_get_bits(tor_addr_t *msk)
 {
   int i;
+  uint32_t mask = tor_addr_to_ipv4h(msk);
   if (mask == 0)
     return 0;
   if (mask == 0xFFFFFFFFu)
@@ -1228,30 +1200,41 @@ addr_mask_get_bits(uint32_t mask)
   return -1;
 }
 
-/** Compare two addresses <b>a1</b> and <b>a2</b> for equality under a
+/** Compare two addresses <b>a</b> and <b>b</b> for equality under a
  * netmask of <b>mbits</b> bits.  Return -1, 0, or 1.
- *
- * XXXX_IP6 Temporary function to allow masks as bitcounts everywhere.  This
- * will be replaced with an IPv6-aware version as soon as 32-bit addresses are
- * no longer passed around.
  */
 int
-addr_mask_cmp_bits(uint32_t a1, uint32_t a2, maskbits_t bits)
+tor_addr_mask_cmp_bits(tor_addr_t *a, tor_addr_t *b, maskbits_t bits)
 {
-  if (bits > 32)
-    bits = 32;
+  int maxbits;
+  const uint8_t *aa, *bb;
+  int aaa, bbb;
+  if (a->family < b->family) return -1;
+  if (a->family > b->family) return 1;
+
+  maxbits = a->family == AF_INET ? 32 : 128;
+  if (bits > maxbits)
+    bits = maxbits;
   else if (bits == 0)
     return 0;
 
-  a1 >>= (32-bits);
-  a2 >>= (32-bits);
+  aa = tor_addr_raw(a);
+  bb = tor_addr_raw(b);
 
-  if (a1 < a2)
-    return -1;
-  else if (a1 > a2)
-    return 1;
-  else
-    return 0;
+  for (; bits >= 8; aa++, bb++, bits -= 8) {
+    if (*aa < *bb) return -1;
+    if (*aa > *bb) return 1;
+  }
+
+  if (bits > 0) {
+    aaa = *aa >> (8-bits);
+    bbb = *bb >> (8-bits);
+
+    if (aaa < bbb) return -1;
+    if (aaa > bbb) return 1;
+  }
+
+  return 0;
 }
 
 /** Parse a string <b>s</b> in the format of (*|port(-maxport)?)?, setting the
@@ -1311,13 +1294,13 @@ parse_port_range(const char *port, uint16_t *port_min_out,
  * *out pointers as appropriate.  Return 0 on success, -1 on failure.
  */
 int
-parse_addr_and_port_range(const char *s, uint32_t *addr_out,
+parse_addr_and_port_range(const char *s, tor_addr_t *addr_out,
                           maskbits_t *maskbits_out, uint16_t *port_min_out,
                           uint16_t *port_max_out)
 {
   char *address;
   char *mask, *port, *endptr;
-  struct in_addr in;
+  tor_addr_t maskbits;
   int bits;
 
   tor_assert(s);
@@ -1341,9 +1324,9 @@ parse_addr_and_port_range(const char *s, uint32_t *addr_out,
    */
 
   if (strcmp(address,"*")==0) {
-    *addr_out = 0;
-  } else if (tor_inet_aton(address, &in) != 0) {
-    *addr_out = ntohl(in.s_addr);
+    tor_addr_from_null(addr_out);
+  } else if (tor_inet_pton(AF_UNSPEC, address, addr_out) != 0) {
+   /* All ok */
   } else {
     log_warn(LD_GENERAL, "Malformed IP %s in address pattern; rejecting.",
              escaped(address));
@@ -1366,8 +1349,8 @@ parse_addr_and_port_range(const char *s, uint32_t *addr_out,
         goto err;
       }
       *maskbits_out = bits;
-    } else if (tor_inet_aton(mask, &in) != 0) {
-      bits = addr_mask_get_bits(ntohl(in.s_addr));
+    } else if (tor_inet_pton(AF_INET, mask, &maskbits) != 0) {
+      bits = tor_addr_mask_get_bits(&maskbits);
       if (bits < 0) {
         log_warn(LD_GENERAL,
                  "Mask %s on address range isn't a prefix; dropping",
@@ -1408,35 +1391,14 @@ tor_inet_ntoa(const struct in_addr *in, char *buf, size_t buf_len)
                       (int)(uint8_t)((a    )&0xff));
 }
 
-/** Given a host-order <b>addr</b>, call tor_inet_ntop() on it
+/** Given a tor_addr_t <b>addr</b>, call tor_inet_ntop() on it
  *  and return a strdup of the resulting address.
  */
 char *
-tor_dup_ip(uint32_t addr)
+tor_dup_ip(tor_addr_t *addr)
 {
   char buf[TOR_ADDR_BUF_LEN];
-  struct in_addr in;
-
-  in.s_addr = htonl(addr);
-  tor_inet_ntop(AF_INET, &in, buf, sizeof(buf));
+  if (!tor_addr_to_str(addr, buf, sizeof(buf),1)) return NULL;
   return tor_strdup(buf);
 }
 
-/**
- * Set *<b>addr</b> to the host-order IPv4 address (if any) of whatever
- * interface connects to the Internet.  This address should only be used in
- * checking whether our address has changed.  Return 0 on success, -1 on
- * failure.
- */
-int
-get_interface_address(int severity, uint32_t *addr)
-{
-  tor_addr_t local_addr;
-  int r;
-
-  r = get_interface_address6(severity, AF_INET, &local_addr);
-  if (r>=0)
-    *addr = tor_addr_to_ipv4h(&local_addr);
-  return r;
-}
-
diff --git a/src/common/address.h b/src/common/address.h
index e41e4c2..f58a31a 100644
--- a/src/common/address.h
+++ b/src/common/address.h
@@ -36,15 +36,14 @@ static INLINE uint32_t tor_addr_to_ipv4n(const tor_addr_t *a);
 static INLINE uint32_t tor_addr_to_ipv4h(const tor_addr_t *a);
 static INLINE uint32_t tor_addr_to_mapped_ipv4h(const tor_addr_t *a);
 static INLINE sa_family_t tor_addr_family(const tor_addr_t *a);
+static INLINE unsigned int tor_addr_protocol(const tor_addr_t *a);
 static INLINE const struct in_addr *tor_addr_to_in(const tor_addr_t *a);
-static INLINE int tor_addr_eq_ipv4h(const tor_addr_t *a, uint32_t u);
+static INLINE const uint8_t *tor_addr_raw(const tor_addr_t *a);
 
 socklen_t tor_addr_to_sockaddr(const tor_addr_t *a, uint16_t port,
-                               struct sockaddr *sa_out, socklen_t len);
-int tor_addr_from_sockaddr(tor_addr_t *a, const struct sockaddr *sa,
-                           uint16_t *port_out);
+                               struct sockaddr_storage *sa_out, socklen_t len);
+int tor_addr_from_sockaddr(tor_addr_t *a, const struct sockaddr *sa, uint16_t *port_out);
 void tor_addr_make_unspec(tor_addr_t *a);
-char *tor_sockaddr_to_str(const struct sockaddr *sa);
 
 /** Return an in6_addr* equivalent to <b>a</b>, or NULL if <b>a</b> is not
  * an IPv6 address. */
@@ -100,6 +99,13 @@ tor_addr_family(const tor_addr_t *a)
 {
   return a->family;
 }
+/** Return the address family of <b>a</b>.  Possible values are:
+ * AF_INET6, AF_INET, AF_UNSPEC. */
+static INLINE unsigned int
+tor_addr_protocol(const tor_addr_t *a)
+{
+  return a->family == AF_INET ? PF_INET : (a->family == AF_INET6 ? PF_INET6 : PF_UNSPEC);
+}
 /** Return an in_addr* equivalent to <b>a</b>, or NULL if <b>a</b> is not
  * an IPv4 address. */
 static INLINE const struct in_addr *
@@ -107,12 +113,11 @@ tor_addr_to_in(const tor_addr_t *a)
 {
   return a->family == AF_INET ? &a->addr.in_addr : NULL;
 }
-/** Return true iff <b>a</b> is an IPv4 address equal to the host-ordered
- * address in <b>u</b>. */
-static INLINE int
-tor_addr_eq_ipv4h(const tor_addr_t *a, uint32_t u)
+/** Return the raw bits of <b>a</b> */
+static INLINE const uint8_t *
+tor_addr_raw(const tor_addr_t *a)
 {
-  return a->family == AF_INET ? (tor_addr_to_ipv4h(a) == u) : 0;
+  return a->family == AF_INET ? (uint8_t *)&a->addr.in_addr.s_addr : tor_addr_to_in6_addr8(a);
 }
 
 /** Length of a buffer that you need to allocate to be sure you can encode
@@ -127,7 +132,6 @@ tor_addr_eq_ipv4h(const tor_addr_t *a, uint32_t u)
 int tor_addr_lookup(const char *name, uint16_t family, tor_addr_t *addr_out);
 char *tor_dup_addr(const tor_addr_t *addr) ATTR_MALLOC;
 const char *fmt_addr(const tor_addr_t *addr);
-const char * fmt_addr32(uint32_t addr);
 int get_interface_address6(int severity, sa_family_t family, tor_addr_t *addr);
 
 /** Flag to specify how to do a comparison between addresses.  In an "exact"
@@ -143,9 +147,10 @@ int tor_addr_compare(const tor_addr_t *addr1, const tor_addr_t *addr2,
                      tor_addr_comparison_t how);
 int tor_addr_compare_masked(const tor_addr_t *addr1, const tor_addr_t *addr2,
                             maskbits_t mask, tor_addr_comparison_t how);
-/** Return true iff a and b are the same address.  The comparison is done
+/** Return true if a and b are the same address.  The comparison is done
  * "exactly". */
 #define tor_addr_eq(a,b) (0==tor_addr_compare((a),(b),CMP_EXACT))
+#define tor_addr_cmp(a,b) tor_addr_compare((a),(b),CMP_EXACT)
 
 unsigned int tor_addr_hash(const tor_addr_t *addr);
 int tor_addr_is_v4(const tor_addr_t *addr);
@@ -164,7 +169,7 @@ int tor_addr_port_parse(const char *s, tor_addr_t *addr_out,
 int tor_addr_parse_mask_ports(const char *s,
                               tor_addr_t *addr_out, maskbits_t *mask_out,
                               uint16_t *port_min_out, uint16_t *port_max_out);
-const char * tor_addr_to_str(char *dest, const tor_addr_t *addr, size_t len,
+const char * tor_addr_to_str(const tor_addr_t *addr, char *dest, size_t len,
                              int decorate);
 int tor_addr_from_str(tor_addr_t *addr, const char *src);
 void tor_addr_copy(tor_addr_t *dest, const tor_addr_t *src);
@@ -180,23 +185,23 @@ void tor_addr_from_ipv6_bytes(tor_addr_t *dest, const char *bytes);
 void tor_addr_from_in6(tor_addr_t *dest, const struct in6_addr *in6);
 int tor_addr_is_null(const tor_addr_t *addr);
 int tor_addr_is_loopback(const tor_addr_t *addr);
+void tor_addr_from_loopback(tor_addr_t *dest,sa_family_t family);
+void tor_addr_from_null(tor_addr_t *dest);
 
-/* IPv4 helpers */
-int is_internal_IP(uint32_t ip, int for_listening) ATTR_PURE;
+/* IP helpers */
 int parse_addr_port(int severity, const char *addrport, char **address,
-                    uint32_t *addr, uint16_t *port_out);
+                    tor_addr_t *addr, uint16_t *port_out);
 int parse_port_range(const char *port, uint16_t *port_min_out,
                      uint16_t *port_max_out);
-int parse_addr_and_port_range(const char *s, uint32_t *addr_out,
+int parse_addr_and_port_range(const char *s, tor_addr_t *addr_out,
                               maskbits_t *maskbits_out, uint16_t *port_min_out,
                               uint16_t *port_max_out);
-int addr_mask_get_bits(uint32_t mask);
-int addr_mask_cmp_bits(uint32_t a1, uint32_t a2, maskbits_t bits);
+int tor_addr_mask_get_bits(tor_addr_t *mask);
+int tor_addr_mask_cmp_bits(tor_addr_t *a, tor_addr_t *b, maskbits_t bits);
 /** Length of a buffer to allocate to hold the results of tor_inet_ntoa.*/
 #define INET_NTOA_BUF_LEN 16
 int tor_inet_ntoa(const struct in_addr *in, char *buf, size_t buf_len);
-char *tor_dup_ip(uint32_t addr) ATTR_MALLOC;
-int get_interface_address(int severity, uint32_t *addr);
+char *tor_dup_ip(tor_addr_t *addr) ATTR_MALLOC;
 
 #endif
 
diff --git a/src/common/compat.c b/src/common/compat.c
index 436d882..38c2fd6 100644
--- a/src/common/compat.c
+++ b/src/common/compat.c
@@ -969,14 +969,15 @@ tor_open_socket(int domain, int type, int protocol)
 
 /** As socket(), but counts the number of open sockets. */
 int
-tor_accept_socket(int sockfd, struct sockaddr *addr, socklen_t *len)
+tor_accept_socket(int sockfd, struct sockaddr_storage *addr, socklen_t *len)
 {
   int s;
+  tor_assert(*len == sizeof(*addr));
 #if defined(HAVE_ACCEPT4) && defined(SOCK_CLOEXEC)
 #define LINUX_CLOEXEC_ACCEPT
-  s = accept4(sockfd, addr, len, SOCK_CLOEXEC);
+  s = accept4(sockfd, (struct sockaddr *)addr, len, SOCK_CLOEXEC);
 #else
-  s = accept(sockfd, addr, len);
+  s = accept(sockfd, (struct sockaddr *)addr, len);
 #endif
   if (s >= 0) {
 #if !defined(LINUX_CLOEXEC_ACCEPT) && defined(FD_CLOEXEC)
@@ -1069,8 +1070,8 @@ tor_socketpair(int family, int type, int protocol, int fd[2])
     int listener = -1;
     int connector = -1;
     int acceptor = -1;
-    struct sockaddr_in listen_addr;
-    struct sockaddr_in connect_addr;
+    struct sockaddr_storage listen_addr;
+    struct sockaddr_storage connect_addr;
     int size;
     int saved_errno = -1;
 
@@ -1109,15 +1110,14 @@ tor_socketpair(int family, int type, int protocol, int fd[2])
     size = sizeof(connect_addr);
     if (getsockname(listener, (struct sockaddr *) &connect_addr, &size) == -1)
       goto tidy_up_and_fail;
-    if (size != sizeof (connect_addr))
+    if (size > sizeof (connect_addr))
       goto abort_tidy_up_and_fail;
     if (connect(connector, (struct sockaddr *) &connect_addr,
                 sizeof(connect_addr)) == -1)
       goto tidy_up_and_fail;
 
     size = sizeof(listen_addr);
-    acceptor = tor_accept_socket(listener,
-                                 (struct sockaddr *) &listen_addr, &size);
+    acceptor = tor_accept_socket(listener, &listen_addr, &size);
     if (acceptor < 0)
       goto tidy_up_and_fail;
     if (size != sizeof(listen_addr))
@@ -1127,10 +1127,10 @@ tor_socketpair(int family, int type, int protocol, int fd[2])
        two sockets.  */
     if (getsockname(connector, (struct sockaddr *) &connect_addr, &size) == -1)
       goto tidy_up_and_fail;
-    if (size != sizeof (connect_addr)
-        || listen_addr.sin_family != connect_addr.sin_family
-        || listen_addr.sin_addr.s_addr != connect_addr.sin_addr.s_addr
-        || listen_addr.sin_port != connect_addr.sin_port) {
+    if (size > sizeof (connect_addr)
+        || listen_addr.sa_family != connect_addr.sa_family
+        || listen_addr.sa_addr.s_addr != connect_addr.sin_addr.s_addr /* XXX-IPv6 */
+        || listen_addr.sa_port != connect_addr.sa_port) {
       goto abort_tidy_up_and_fail;
     }
     fd[0] = connector;
@@ -1522,25 +1522,6 @@ get_user_homedir(const char *username)
 }
 #endif
 
-/** Set *addr to the IP address (in dotted-quad notation) stored in c.
- * Return 1 on success, 0 if c is badly formatted.  (Like inet_aton(c,addr),
- * but works on Windows and Solaris.)
- */
-int
-tor_inet_aton(const char *str, struct in_addr* addr)
-{
-  unsigned a,b,c,d;
-  char more;
-  if (tor_sscanf(str, "%3u.%3u.%3u.%3u%c", &a,&b,&c,&d,&more) != 4)
-    return 0;
-  if (a > 255) return 0;
-  if (b > 255) return 0;
-  if (c > 255) return 0;
-  if (d > 255) return 0;
-  addr->s_addr = htonl((a<<24) | (b<<16) | (c<<8) | d);
-  return 1;
-}
-
 /** Given <b>af</b>==AF_INET and <b>src</b> a struct in_addr, or
  * <b>af</b>==AF_INET6 and <b>src</b> a struct in6_addr, try to format the
  * address and store it in the <b>len</b>-byte buffer <b>dst</b>.  Returns
@@ -1639,12 +1620,25 @@ tor_inet_ntop(int af, const void *src, char *dst, size_t len)
  * sometimes needs to format ipv6 addresses even on platforms without ipv6
  * support.) */
 int
-tor_inet_pton(int af, const char *src, void *dst)
-{
-  if (af == AF_INET) {
-    return tor_inet_aton(src, dst);
+tor_inet_pton(int af, const char *src, tor_addr_t *dst)
+{
+  if (af == AF_UNSPEC) {
+    if (tor_inet_pton(AF_INET, src, dst) == 1) return 1;
+    return tor_inet_pton(AF_INET6, src, dst);
+  } else if (af == AF_INET) {
+    unsigned a,b,c,d;
+    char more;
+    /* XXX: There are 5 parameters (4x %u, 1x %c), why compare to 4 as a result!? */
+    if (tor_sscanf(src, "%3u.%3u.%3u.%3u%c", &a,&b,&c,&d,&more) == 4) {
+      if (a > 255) return 0;
+      if (b > 255) return 0;
+      if (c > 255) return 0;
+      if (d > 255) return 0;
+      if (dst) tor_addr_from_ipv4n(dst, htonl((a<<24) | (b<<16) | (c<<8) | d));
+      return 1;
+    }
   } else if (af == AF_INET6) {
-    struct in6_addr *out = dst;
+    tor_addr_t *out = dst ? dst : NULL;
     uint16_t words[8];
     int gapPos = -1, i, setWords=0;
     const char *dot = strchr(src, '.');
@@ -1718,38 +1712,13 @@ tor_inet_pton(int af, const char *src, void *dst)
               sizeof(uint16_t)*nToMove);
       memset(&words[gapPos], 0, sizeof(uint16_t)*gapLen);
     }
-    for (i = 0; i < 8; ++i) {
-      out->s6_addr[2*i  ] = words[i] >> 8;
-      out->s6_addr[2*i+1] = words[i] & 0xff;
+    for (i = 0; dst && i < 8; ++i) {
+      out->addr.in6_addr.s6_addr[2*i  ] = words[i] >> 8;
+      out->addr.in6_addr.s6_addr[2*i+1] = words[i] & 0xff;
     }
 
     return 1;
-  } else {
-    return -1;
   }
-}
-
-/** Similar behavior to Unix gethostbyname: resolve <b>name</b>, and set
- * *<b>addr</b> to the proper IP address, in host byte order.  Returns 0
- * on success, -1 on failure; 1 on transient failure.
- *
- * (This function exists because standard windows gethostbyname
- * doesn't treat raw IP addresses properly.)
- */
-int
-tor_lookup_hostname(const char *name, uint32_t *addr)
-{
-  tor_addr_t myaddr;
-  int ret;
-
-  if ((ret = tor_addr_lookup(name, AF_INET, &myaddr)))
-    return ret;
-
-  if (tor_addr_family(&myaddr) == AF_INET) {
-    *addr = tor_addr_to_ipv4h(&myaddr);
-    return ret;
-  }
-
   return -1;
 }
 
diff --git a/src/common/compat.h b/src/common/compat.h
index b658ed5..8a7f976 100644
--- a/src/common/compat.h
+++ b/src/common/compat.h
@@ -397,7 +397,7 @@ typedef int socklen_t;
 
 int tor_close_socket(int s);
 int tor_open_socket(int domain, int type, int protocol);
-int tor_accept_socket(int sockfd, struct sockaddr *addr, socklen_t *len);
+int tor_accept_socket(int sockfd, struct sockaddr_storage *addr, socklen_t *len);
 int get_n_open_sockets(void);
 
 #define tor_socket_send(s, buf, len, flags) send(s, buf, len, flags)
@@ -465,10 +465,11 @@ struct sockaddr_in6 {
 };
 #endif
 
-int tor_inet_aton(const char *cp, struct in_addr *addr) ATTR_NONNULL((1,2));
+/* Need for tor_addr_t till we kill off these 'compatibility' functions */
+#include "address.h"
+
 const char *tor_inet_ntop(int af, const void *src, char *dst, size_t len);
-int tor_inet_pton(int af, const char *src, void *dst);
-int tor_lookup_hostname(const char *name, uint32_t *addr) ATTR_NONNULL((1,2));
+int tor_inet_pton(int af, const char *src, tor_addr_t *dst);
 void set_socket_nonblocking(int socket);
 int tor_socketpair(int family, int type, int protocol, int fd[2]);
 int network_init(void);
diff --git a/src/or/buffers.c b/src/or/buffers.c
index 70f8b4a..540bf4c 100644
--- a/src/or/buffers.c
+++ b/src/or/buffers.c
@@ -1710,7 +1710,7 @@ parse_socks(const char *data, size_t datalen, socks_request_t *req,
           else
             tor_addr_from_ipv4n(&destaddr, get_uint32(data+4));
 
-          tor_addr_to_str(tmpbuf, &destaddr, sizeof(tmpbuf), 1);
+          tor_addr_to_str(&destaddr, tmpbuf, sizeof(tmpbuf), 1);
 
           if (strlen(tmpbuf)+1 > MAX_SOCKS_ADDR_LEN) {
             log_warn(LD_APP,
